/**
  Sample code for thread migration
  in package NET.shudo.moba.

  Copy this file to the directory which is in CLASSPATH and compile.
    % javac MigrationThread.java
  Make sure that this class (MigrationThread) is found in your CLASSPATH
  at the source host.
  Type the following command at the source and destination host
    % (somewhere)/moba/bin/mobaplace &
  to invoke MOBA place which receive threads from the network.
  Now execute at the source host.
    % java MigrationThread <destination_host_name>

  @author SHUDOH Kazuyuki
 */

import java.io.FileOutputStream;
import java.io.FileInputStream;
import java.io.PrintStream;
import java.io.IOException;

import NET.shudo.moba.lang.MobaThread;


class MigrationThread {
  private void start(String[] argv) {
    // åɤεư
    Thread t = null;
    if (argv.length > 0)
      t = new AThreadMigrant(argv[0]);
    else
      t = new AThreadMigrant();
    t.start();

    // ưåɤνλԤ
    boolean joined = true;
    do {
      try {
	t.join();
      } catch (InterruptedException e) { joined = false; }
    } while (!joined);
  }

  public static void main(String[] argv) {
    new MigrationThread().start(argv);
  }
}


/**
 * ư륹å
 */
class AThreadMigrant extends MobaThread {
  private static final String DEFAULT_HOST = "host.defaultdomain.com";
  private static final String THREAD_FNAME = "output";

  private String host = null;

  public AThreadMigrant() {
    this(DEFAULT_HOST);
  }
  public AThreadMigrant(String host) {
    this.host = host;
  }


  public void run() {
    System.out.println("Now externalize myself(Thread#currentThread()).");

    // ư or fork
    try {
      // migration
      MobaThread.goTo(this.host);
      // fork
//      MobaThread.fork(this.host);
    }
    catch (IOException e) { e.printStackTrace(); System.exit(1); }

    if (((MobaThread)Thread.currentThread()).isInternalized()) {
      System.out.println("I've migrated !");
    }
    else {
      System.out.println("Migration is done.");
	// This message is never shown
	// because he, current thread is gone. :)
    }
  }
}
