/**
  Sample code for thread externalizer
  in package NET.shudo.moba.
  Copy this file to the directory which is in CLASSPATH and compile
    % javac WriteSelfTest.java
  and execute:
    % java WriteSelfTest

  A file 'output' is created. To resume this externalized thread, type
    % ../bin/readthread output

  @author SHUDOH Kazuyuki
 */

import java.io.FileOutputStream;
import java.io.FileInputStream;
import java.io.IOException;

import NET.shudo.moba.lang.MobaThread;
import NET.shudo.moba.io.ObjectWriter;
import NET.shudo.moba.io.ObjectReader;
import NET.shudo.moba.io.ThreadWriter;
import NET.shudo.moba.io.ThreadReader;
import NET.shudo.moba.reflect.MetaClass;


class WriteSelfTest {
  private void start() {
    /* åɤεư */
    Runnable r = new ASelfWriter();
    Thread t = new MobaThread(r);	// ¸ǽ Thread 饹
    t.start();

    /* ưåɤνλԤ */
    boolean joined = true;
    do {
      try {
	t.join();
      } catch (InterruptedException e) { joined = false; }
    } while (!joined);
  }

  public static void main(String[] argv) {
    new WriteSelfTest().start();
  }
}


/**
 * Ȥ¸륹å
 */
class ASelfWriter implements Runnable {
  private static final String THREAD_FNAME = "output";

  public void run() {
    ObjectWriter out;
    try {
      out =
	new ThreadWriter(new FileOutputStream(THREAD_FNAME));

      //System.out.println("call writeSelf().");
      this.writeSelf(out);
      //System.out.println("writeSelf() done.");

      out.close();
    }
    catch (IOException e) { e.printStackTrace(); System.exit(1); }
  }


  private void writeSelf(ObjectWriter out) {
    Thread crntThread = Thread.currentThread();	// ȤΥå

    System.out.println("Now externalize myself(Thread#currentThread()).");

    // 񤭽Ф
    try {
      out.writeObject(crntThread);
      out.flush();	// out ¸Դ ?
    }
    catch (IOException e) { e.printStackTrace(); System.exit(1); }


    if (((MobaThread)Thread.currentThread()).isInternalized()) {
      System.out.println("I'm a thread internalized !");
    }
    else {
      System.out.println("Externalization to the file `" +
				THREAD_FNAME + "' done.");
    }
  }
}
