/*
 * Copyright (C) 1996,1997,1998
 *	SHUDOH Kazuyuki
 *
 * Permission to use, copy, modify and distribute this software
 * and its documentation for non-commercial purposes and without
 * fee is hereby granted provided this copyright notice.
 *
 * $Id$
 */

package NET.shudo.moba.lang;

import java.util.Random;
import NET.shudo.moba.reflect.*;
import NET.shudo.moba.io.ThreadWriter;
import NET.shudo.moba.io.ObjectWriter;
import NET.shudo.moba.io.ObjectReader;
// for migration
import NET.shudo.moba.place.ThreadExporter;
import java.io.IOException;
import java.net.InetAddress;


/**
 * streamήȤν롢ưǽʥåɤΥ饹
 */
public
class MobaThread extends Thread {
  private static MetaClass threadMetaClass = null;
  private static Object threadMetaClassMutex = new Object();

  private static Random hashCodeGenerator =
	new Random(System.currentTimeMillis());

  /**
   * hash value
   */
  private int hashValue;
  /**
   * 
   */
  private long generatedTime;
  /**
   * εꡣ
   */
  private PlaceAddress genedPlace = null;
  /**
   * ε֤
   */
  public PlaceAddress generatedPlace() { return this.genedPlace; }
  /**
   * εꤹ롣
   */
  public void generatedPlace(PlaceAddress place) {
    this.genedPlace = place;
  }


  public MobaThread() {
    super();  init();
  }
  public MobaThread(Runnable target) {
    super(target);  init();
  }
  public MobaThread(ThreadGroup group, Runnable target) {
    super(group, target);  init();
  }
  public MobaThread(String name) {
    super(name);  init();
  }
  public MobaThread(ThreadGroup group, String name) {
    super(group, name);  init();
  }
  public MobaThread(ThreadGroup group, Runnable target, String name) {
    super(group, target, name);  init();
  }


  public int hashCode() {
    return this.hashValue;
  }

  /**
   * ϥåͤѹ롣
   */
  public int changeHashCode() {
    this.hashValue = hashCodeGenerator.nextInt();

    return this.hashValue;
  }


  public String toString() {
    return "Moba" + super.toString() + "@" + Integer.toHexString(hashCode());
  }


  private void init() {
    // Ͽ
    this.generatedTime = System.currentTimeMillis();

    // Ͽ
    try {
      generatedPlace(new PlaceAddress(InetAddress.getLocalHost()));
    }
    catch (java.net.UnknownHostException e) {
      // not reached.
    }

    // hashCode() 
    this.changeHashCode();

    // java.lang.Thread  MetaClass 
    synchronized(threadMetaClassMutex) {
      if (threadMetaClass == null) {
	try {
	  threadMetaClass = MetaClass.get("java.lang.Thread");
	}
	catch (ClassNotFoundException e) {
	  // not reached.
	  e.printStackTrace();  System.exit(1);
	}
      }
    }
  }


  /**
   * åɤб Runnable 饹Υ󥹥󥹤롣
   */
  public Runnable runnableInstance() {
    MetaField field = null;
    try {
      field = threadMetaClass.field("target");
    }
    catch (FieldNotFoundException e) { return null; }

    return (Runnable)field.getObjectValue(this);
  }


  /**
   * ꤷåɤ򡢻ꤷ ThreadGroup ˽°롣
   */
  public static void setThreadGroup(Thread t, ThreadGroup newGroup)
	throws Exception {
    MetaClass mc;
    MetaMethod mm;
    MetaField mf;

    Object[] invokeArgs = new Object[1];
    invokeArgs[0] = t;

    ThreadGroup origGroup = t.getThreadGroup();
    if (origGroup.equals(newGroup))  return;

    //  group ȴ
    mc = MetaClass.get("java.lang.ThreadGroup");
    mm = mc.method("remove", "(Ljava/lang/Thread;)V");
    mm.invoke(origGroup, invokeArgs);
	// t.getThreadGroup().remove(t);

    // MobaPlace.threadPool 
    mc = MetaClass.get("java.lang.Thread");
    mf = mc.field("group");
    mf.setObjectValue(t, newGroup);
	// t.group = newGroup;

    mc = MetaClass.get("java.lang.ThreadGroup");
    mm = mc.method("add", "(Ljava/lang/Thread;)V");
    mm.invoke(newGroup, invokeArgs);
	// newGroup.add(t);
  }


  /** Υåɤ¾η׻˰ư롣(vt. move) */
  public void moveTo(PlaceAddress addr) throws IOException {
    ThreadExporter.moveTo(this, addr);
  }
  /** Υåɤ¾η׻˰ư롣(vt. move) */
  public void moveTo(String host) throws IOException {
    ThreadExporter.moveTo(this, new PlaceAddress(host));
  }
  /** Υåɤ¾η׻˰ư롣(vt. move) */
  public void moveTo(InetAddress dest) throws IOException {
    ThreadExporter.moveTo(this, new PlaceAddress(dest));
  }
  /** Υåɤ¾η׻˰ư롣(vt. move) */
  public void moveTo(String host, int port) throws IOException {
    ThreadExporter.moveTo(this, new PlaceAddress(host, port));
  }
  /** Υåɤ¾η׻˰ư롣(vt. move) */
  public void moveTo(InetAddress dest, int port) throws IOException {
    ThreadExporter.moveTo(this, new PlaceAddress(dest, port));
  }

  /**  (Thread#currentThread())  host ˰ư롣(vi. go) */
  public static void goTo(PlaceAddress addr) throws IOException {
    ThreadExporter.moveTo((MobaThread)Thread.currentThread(), addr);
  }
  /**  (Thread#currentThread())  host ˰ư롣(vi. go) */
  public static void goTo(String host) throws IOException {
    ThreadExporter.moveTo((MobaThread)Thread.currentThread(),
			new PlaceAddress(host));
  }
  /**  (Thread#currentThread())  host ˰ư롣(vi. go) */
  public static void goTo(InetAddress dest) throws IOException {
    ThreadExporter.moveTo((MobaThread)Thread.currentThread(),
			new PlaceAddress(dest));
  }
  /**  (Thread#currentThread())  host ˰ư롣(vi. go) */
  public static void goTo(String host, int port) throws IOException {
    ThreadExporter.moveTo((MobaThread)Thread.currentThread(),
			new PlaceAddress(host, port));
  }
  /**  (Thread#currentThread())  host ˰ư롣(vi. go) */
  public static void goTo(InetAddress dest, int port) throws IOException {
    ThreadExporter.moveTo((MobaThread)Thread.currentThread(),
			new PlaceAddress(dest, port));
  }

  /** Υåɤ¾η׻˥ԡ롣(cf. fork(2)) */
  public void forkThisThread(PlaceAddress addr) throws IOException {
    ThreadExporter.fork(this, addr);
  }
  /** Υåɤ¾η׻˥ԡ롣(cf. fork(2)) */
  public void forkThisThread(String host) throws IOException {
    ThreadExporter.fork(this, new PlaceAddress(host));
  }
  /** Υåɤ¾η׻˥ԡ롣(cf. fork(2)) */
  public void forkThisThread(InetAddress dest) throws IOException {
    ThreadExporter.fork(this, new PlaceAddress(dest));
  }
  /** Υåɤ¾η׻˥ԡ롣(cf. fork(2)) */
  public void forkThisThread(String host, int port) throws IOException {
    ThreadExporter.fork(this, new PlaceAddress(host, port));
  }
  /** Υåɤ¾η׻˥ԡ롣(cf. fork(2)) */
  public void forkThisThread(InetAddress dest, int port) throws IOException {
    ThreadExporter.fork(this, new PlaceAddress(dest, port));
  }

  /**
   * Ȥ¾η׻˥ԡ롣(cf. fork(2))
   * @return true to created thread, false to original thread
   */
  public static boolean fork(PlaceAddress addr) throws IOException {
    return ThreadExporter.fork((MobaThread)Thread.currentThread(), addr);
  }
  /**
   * Ȥ¾η׻˥ԡ롣(cf. fork(2))
   * @return true to created thread, false to original thread
   */
  public static boolean fork(String host) throws IOException {
    return ThreadExporter.fork((MobaThread)Thread.currentThread(),
			new PlaceAddress(host));
  }
  /**
   * Ȥ¾η׻˥ԡ롣(cf. fork(2))
   * @return true to created thread, false to original thread
   */
  public static boolean fork(InetAddress dest) throws IOException {
    return ThreadExporter.fork((MobaThread)Thread.currentThread(),
			new PlaceAddress(dest));
  }
  /**
   * Ȥ¾η׻˥ԡ롣(cf. fork(2))
   * @return true to created thread, false to original thread
   */
  public static boolean fork(String host, int port) throws IOException {
    return ThreadExporter.fork((MobaThread)Thread.currentThread(),
			new PlaceAddress(host, port));
  }
  /**
   * Ȥ¾η׻˥ԡ롣(cf. fork(2))
   * @return true to created thread, false to original thread
   */
  public static boolean fork(InetAddress dest, int port) throws IOException {
    return ThreadExporter.fork((MobaThread)Thread.currentThread(),
			new PlaceAddress(dest, port));
  }


  private boolean internalized = false;

  /**
   * Υåɤ internalization ǹ줿ΤĴ٤롣
   *
   * @return internalized åɤʤ鿿֤
   * @see NET.shudo.moba.io.ObjectReader#readObject()
   */
  public boolean isInternalized() { return internalized; }

  public boolean isInternalized(boolean flag) {
    boolean ret = internalized;	// ¸
    internalized = flag;
    return ret;
  }


  /**
   * internalize 줿 MobaThread ư롣Thread#start() <BR>
   * boot() åɤ Thread#suspend() Ǽ¹ԤƳ롣<BR>
   * MOBA place ˰ưåɤϼưŪ boot(), resume() 롣
   *
   * @see java.lang.Thread#start()
   * @see java.lang.Thread#resume()
   */
  public native void boot();

  /**
   * Ϳ줿åɤ context Ϳ줿ȥ꡼˽񤭽Ф
   */
  public native void writeContextTo(ObjectWriter out) throws IOException;

  /**
   * Ϳ줿åɤ context Ϳ줿ȥ꡼फ鹽롣
   */
  public static native void readContextFrom(
		ObjectReader in, Thread thr, ClassLoader loader);


  /**
   * Υåɤθߤ PC ˴ؤʸȤ롣
   */
  public native String currentPCString();


  // 饤֥ΰ
  private static boolean libLoaded = false;
  private static Object libLoadedLock = new Object();

  /**
   * native methods ޤ饤֥ɤ롣
   */
  public static void loadLibrary() {
    synchronized(libLoadedLock) {
      if (!libLoaded) {
	// native method 饤֥Υ
	System.loadLibrary("Moba");
	libLoaded = true;
      }
    }
  }
}
