extern void writeBytes(struct Hjava_io_OutputStream *out, char *str, int len) {
  static HArrayOfByte *array = NULL;
  static int array_len = -1;
  static char *body = NULL;

#ifdef WRITE_VERBOSE
  printf("writeBytes(out, 0x%x, %d) called.\n", (int)str, len);
  fflush(stdout);
#endif

  if ((!array) || (len > array_len)) {
    array_len = (len / ARRAY_BLOCK_SIZE + 1) * ARRAY_BLOCK_SIZE;

    removeGlobalHandle((HObject *)array);
    /* DeleteGlobalRef(jobject);  in JNI */

    array = makeArrayOfByte(NULL, array_len);
    body = ((ArrayOfByte *)unhand(array))->body;

    registerGlobalHandle((HObject *)array);
    /* NewGlobalRef(jobject);  in JNI */
  }

  memcpy(body, str, len);
  /*body[len] = '\0';*/

  writeArrayOfByte(out, array, 0, len);
}


extern char *readBytes(struct Hjava_io_InputStream *in, int len) {
  static HArrayOfByte *array = NULL;
  static int array_len = -1;

  char *body;

  if ((!array) || (len > array_len)) {
    array_len = (len / ARRAY_BLOCK_SIZE + 1) * ARRAY_BLOCK_SIZE;

    removeGlobalHandle((HObject *)array);
    /* DeleteGlobalRef(jobject);  in JNI */

    array = makeArrayOfByte(NULL, array_len);

    registerGlobalHandle((HObject *)array);
    /* NewGlobalRef(jobject);  in JNI */
  }

  if (readArrayOfByte(in, array, 0, len) < 0)
    return NULL;

  body = ((ArrayOfByte *)unhand(array))->body;
  body[len] = '\0';	/* terminate */

  return body;
}
