/*
 * Copyright (C) 1996,1997,1998
 *	SHUDOH Kazuyuki
 *
 * Permission to use, copy, modify and distribute this software
 * and its documentation for non-commercial purposes and without
 * fee is hereby granted provided this copyright notice.
 *
 * $Id$
 */

package NET.shudo.moba.place;


import java.lang.reflect.Field;
import java.lang.reflect.Method;
import java.lang.reflect.Constructor;
import java.lang.reflect.Modifier;
import java.util.Dictionary;
import java.util.Hashtable;
import java.util.Vector;
import java.io.File;
import java.io.OutputStream;
import java.io.PrintStream;
import java.io.IOException;
import java.net.UnknownHostException;
import NET.shudo.moba.lang.MobaThread;
import NET.shudo.moba.lang.PlaceAddress;
import NET.shudo.moba.lang.PlaceAddress;
// write, read ޥɤΤ
import java.io.FileOutputStream;
import java.io.FileInputStream;
import NET.shudo.moba.io.ObjectWriter;
import NET.shudo.moba.io.ObjectReader;
import NET.shudo.moba.io.ThreadWriter;
import NET.shudo.moba.io.ThreadReader;
// ThreadGroup Τ
import NET.shudo.moba.reflect.MetaClass;
import NET.shudo.moba.reflect.MetaField;
import NET.shudo.moba.reflect.MetaMethod;


/**
 * ޥɥΥޥɤ륯饹<BR>
 *
 * "Method ޥ̾(String[])" Ȥ롣<BR>
 * public ᥽åɤȥޥɤû̲ǽˤʤ롣
 * protected ᥽åɤȥޥɤṳ̂Ǥʤ
 *
 * @see NET.shudo.moba.place.CommandShell
 * @see NET.shudo.moba.place.CommandServer
 */
public
class Command {
  private static final String PERSIST_SUFFIX = ".moba";


  /**
   * ޥɥ뤬դ륳ޥɤɽ<BR>
   * ʸ (String)  key ˡ (Method) ֤
   */
  protected static Dictionary commandTable;	// key: String, value: Method
  protected static Vector commandVector;

  private static final String helpIndent = "  ";
  /**
   * usage ɽ
   */
  private static Dictionary usageTable;
  private static String usageAll;

  /**
   * ޥɤɽ
   */
  private static Dictionary descTable;


  static {
    // إץåɽ
    usageTable = new Hashtable();
    descTable = new Hashtable();
    StringBuffer buf = new StringBuffer();
    Field[] fields = (new Command()).getClass().getDeclaredFields();

    for (int i = 0; i < fields.length; i++) {
      Field field = fields[i];
      int modifier = field.getModifiers();

      if (!Modifier.isStatic(modifier))  continue;	// static field ̵

      String name = field.getName();

      try {
	if (name.startsWith("usageOf")) {
	  String usage = (String)field.get(null);
	  buf.append(helpIndent);  buf.append(usage);  buf.append('\n');
	  usageTable.put(name.substring(7), usage);
	}
	else if (name.startsWith("descOf")) {
	  String desc = (String)field.get(null);
	  descTable.put(name.substring(6), desc);
	}
      }
      catch (IllegalAccessException e) {
	continue;
      }
    }

    usageAll = buf.toString();


    // ޥɤɽ
    commandTable = new Hashtable();
    commandVector = new Vector();
    Method[] methods = (new Command()).getClass().getDeclaredMethods();

    for (int i = 0; i < methods.length; i++) {
      Method method = methods[i];
      int modifier = method.getModifiers();

      // private, static ʥ᥽åɤ̵뤹
      if (Modifier.isPrivate(modifier))  continue;
      if (Modifier.isStatic(modifier))  continue;

      String name = method.getName();

      // ޥɤɽϿ
      commandTable.put(name, method);
      commandVector.addElement(method);
//System.out.println(name);
//System.out.flush();

      if (Modifier.isPublic(modifier)) {
	// ޥɤû̷ɽϿ
	for (int j = name.length() - 1; j > 0; j--) {
//System.out.println(name.substring(0, j));
//System.out.flush();
	  commandTable.put(name.substring(0, j), method);
	}
      }
    }

    // üû̷Ͽ
    try {
      Class[] methodArgs = new Class[1];
      methodArgs[0] = Class.forName("[Ljava.lang.String;");
      Class cmdClazz = Class.forName("NET.shudo.moba.place.Command");
      Method method;

      method = cmdClazz.getDeclaredMethod("help", methodArgs);
      commandTable.put("?", method);

      method = cmdClazz.getDeclaredMethod("start", methodArgs);
      commandTable.put("!", method);
    }
    catch (Exception e) {
      // ̵
    }
  }	// static {...}


  private CommandShell shell;
  private PrintStream out;
  private boolean debug = false;


  public Command(CommandShell sh, PrintStream out, boolean debug) {
    this.shell = sh;
    this.out = out;
  }
  public Command(CommandShell sh, PrintStream out) {
    this(sh, out, false);
  }
  private Command() {}


  /**
   * Ϳ줿ʸб륳ޥɤ֤
   */
  public static Method get(String cmd) {
    return (Method)commandTable.get(cmd);
  }


  /**
   * 顼å
   */
  protected void error(String msg) {
    out.print("Error: ");
    out.println(msg);
    out.flush();
  }


  /* ʲΥޥ */

  private static final String usageOflist = "list";
  private static final String descOflist =
	"List all stationary and mobile threads on this place.";

  public void list(String[] args) {
    listThreadGroup(MobaPlace.threadPool, false, "  ");
//(new NET.shudo.moba.util.ThreadLister()).listAllThreads(out);  out.flush();
  }

  private void listThreadGroup(ThreadGroup g) {
    listThreadGroup(g, true, "");
  }
  private void listThreadGroup(ThreadGroup g,
	boolean printOwn, String indent) {
    int threadCount = g.activeCount();
    int groupCount = g.activeGroupCount();
    Thread[] threads = new Thread[threadCount];
    ThreadGroup[] groups = new ThreadGroup[groupCount];
    int i;

    g.enumerate(threads, false);
    g.enumerate(groups, false);

    if (printOwn) {
      out.println(indent + threadID(g) + " group:\"" + g.getName() + "\""
		+ ((g.isDaemon()) ? " Daemon" : "")
		);
    }

    for (i = 0; i < threads.length; i++) {
      Thread t = threads[i];
      out.println(indent + threadID(t) + " \"" + t.getName() + "\""
		+ ((t instanceof MobaThread) ? " Mobile" : "")
		+ ((t.isDaemon()) ? " Daemon" : "")
		+ ((t.isAlive()) ? "" : " Not_alive")
		);
//NET.shudo.moba.util.ReferrerLister.show(out, t, MobaPlace.threadPool);
    }

    for (i = 0; i < groups.length; i++) {
      listThreadGroup(groups[i], true, indent + "  ");
    }
  }


  private static final int THREAD_ID_LAW = 10000;
  private static int threadID(Object obj) {
    return (obj.hashCode() & 0x7fffffff) % THREAD_ID_LAW;
  }

  private Object /* Thread or ThreadGroup */ threadByID(
					int val, ThreadGroup g) {
    int threadCount = g.activeCount();
    int groupCount = g.activeGroupCount();
    Thread[] threads = new Thread[threadCount];
    ThreadGroup[] groups = new ThreadGroup[groupCount];
    int i;

    g.enumerate(threads, true);
    g.enumerate(groups, true);

    for (i = 0; i < threadCount; i++)
      if (threadID(threads[i]) == val)  return threads[i];
    for (i = 0; i < groupCount; i++)
      if (threadID(groups[i]) == val)  return groups[i];
    return null;
  }


  private static final String usageOfwrite = "write threadID key";
  private static final String descOfwrite =
	"Save the thread and bind it to the key.";

  public void write(String[] args) {
    if (args.length < 3) {
      error("Thread ID and key must be specified.");
      return;
    }

    int id = -1;
    try { id = Integer.parseInt(args[1]); }
    catch (NumberFormatException e) {
      error("Format of \"" + args[1] + "\" is illegal.");
      return;
    }

    // ꤵ줿 ID ĥåɤ
    Object target = threadByID(id, MobaPlace.threadPool);
    if (target == null) {
      error("Thread which has ID \"" + id + "\" doesn't exist.");
      return;
    }
    if (!(target instanceof MobaThread)) {
      error("Thread \"" + target + "\" is not externalizable.");
      return;
    }
    MobaThread t = (MobaThread)target;

    // key б륹åɳǼѰ
    String key = args[2];
    if (key.indexOf(File.separator) >= 0) {
      error("Key must not contain \"" + File.separator + "\".");
      return;
    }

    // Ǽ
    ObjectWriter oout;
    try {
      oout = new ThreadWriter(new FileOutputStream(key + PERSIST_SUFFIX));
      oout.writeObject(t);
    }
    catch (IOException e) {
      error("Opening or wrinting failed: " + key);
    }
  }


  private static final String usageOfread = "read key [key ...]";
  private static final String descOfread =
	"Load the thread bound to the key and start it.";

  public void read(String[] args) {
    if (args.length < 2) {
      error("Command \"read\" requires one argument at least.");  return;
    }

    for (int i = 1; i < args.length; i++) {
      String key = args[i];

      Runnable importer = null;
      try {
	importer = new ThreadImporter(key + PERSIST_SUFFIX, debug);
      }
      catch (IOException e) {
	error("Thread bound to the key \"" + key + "\" is not found.");
	continue;
      }
      Thread t = new Thread(importer, "Thread Importer");
      t.start();
    }
  }


  private static final String usageOfstopall = "stopall";
  private static final String descOfstopall =
	"Force all threads on this place to stop executing.";

  public void stopall(String[] args) {
    MobaPlace.threadPool.stop();
  }


  private static final String usageOfsuspend = "suspend threadID [ID ...]";
  private static final String descOfsuspend = "Suspend running threads.";

  public void suspend(String[] args) {
    if (args.length < 2) {
      error("Command \"suspend\" requires one argument at least.");  return;
    }

    for (int i = 1; i < args.length; i++) {
      String arg = args[i];  int id;

      try { id = Integer.parseInt(arg); }
      catch (NumberFormatException e) {
	error("Format of \"" + arg + "\" is illegal.");
	continue;
      }

      Object target = threadByID(id, MobaPlace.threadPool);
      if (target == null) {
	error("Thread which has ID \"" + id + "\" doesn't exist.");
	continue;
      }
      else if (target instanceof Thread) {
	((Thread)target).suspend();
      }
      else if (target instanceof ThreadGroup) {
	((ThreadGroup)target).suspend();
      }
    }
  }


  private static final String usageOfresume = "resume threadID [ID ...]";
  private static final String descOfresume = "Resume suspended threads.";

  public void resume(String[] args) {
    if (args.length < 2) {
      error("Command \"resume\" requires one argument at least.");  return;
    }

    for (int i = 1; i < args.length; i++) {
      String arg = args[i];  int id;

      try { id = Integer.parseInt(arg); }
      catch (NumberFormatException e) {
	error("Format of \"" + arg + "\" is illegal.");
	continue;
      }

      Object target = threadByID(id, MobaPlace.threadPool);
      if (target == null) {
	error("Thread which has ID \"" + id + "\" doesn't exist.");
	continue;
      }
      else if (target instanceof Thread) {
	((Thread)target).resume();
      }
      else if (target instanceof ThreadGroup) {
	((ThreadGroup)target).resume();
      }
    }
  }


  private static final String usageOfstop = "stop threadID [ID ...]";
  private static final String descOfstop =
	"Force the threads to stop executing.";

  public void stop(String[] args) {
    if (args.length < 2) {
      error("Command \"stop\" requires one argument at least.");  return;
    }

    for (int i = 1; i < args.length; i++) {
      String arg = args[i];  int id;

      try { id = Integer.parseInt(arg); }
      catch (NumberFormatException e) {
	error("Format of \"" + arg + "\" is illegal.");
	continue;
      }

      Object target = threadByID(id, MobaPlace.threadPool);
      if (target == null) {
	error("Thread which has ID \"" + id + "\" doesn't exist.");
	continue;
      }
      else if (target instanceof Thread) {
	Thread t = (Thread)target;
	t.stop();
	t = null;
      }
      else if (target instanceof ThreadGroup) {
	((ThreadGroup)target).stop();
      }
    }
  }


  private static final String usageOfstart =
	"start class_name[@host[:port]] [...]";
  private static final String descOfstart =
	"Load specified thread classes from the host"
	+ ", and create instances of it"
	+ ", and cause those to begin execution.";

  public void start(String[] args) {
    if (args.length < 2) {
      error("Command \"start\" requires class names.");  return;
    }

    for (int i = 1; i < args.length; i++) {
      String className = args[i];
      MobaClassLoader loader = null;

      // 饹Υɸ
      int sepIndex = className.lastIndexOf('@');
      if (sepIndex >= 0) {	// 饹ɸꤵ줿
	String placeAddr = className.substring(sepIndex + 1);
	try {
	  loader = MobaClassLoader.get(placeAddr);
	}
	catch (IOException e) {
	  error("Fail initializing a class loader gets class def. from: "
		+ placeAddr);
	  continue;
	}

	className = className.substring(0, sepIndex);
      }


      // 饹֥Ȥ
      MetaClass clazz = null;

      try {
	clazz = MetaClass.get(className, loader);
      }
      catch (ClassNotFoundException e) {
	error("Class \"" + className + "\" is not found.");
	continue;
      }

      // 󥹥󥹤
      Object obj = null;
      try {
	obj = clazz.newInstance();
      }
      catch (InstantiationException e) {
	error("Instantiation an instance of class \""
		+ className + "\" fails.");
	continue;
      }
/*
// java.lang.Class 饤󥹥󥹤뤿ˤɬ
      catch (IllegalAccessException e) {
	error("The class \""
		+ className + "\" or constructor is not accessible.");
	continue;
      }
*/

      synchronized (obj) {
	try {
	  if (obj instanceof Thread) {
	    Thread t = (Thread)obj;

	    // åɤ MobaPlace.threadPool ˽°
	    MobaThread.setThreadGroup(t, MobaPlace.threadPool);
	  }	// if (obj instanceof Thread)
	}
	catch (Exception e) {
	  // not reached.
	  e.printStackTrace();
	}
      }	// synchronized (obj)

      Thread t = null;
      if (obj instanceof Thread) {
	t = (Thread)obj;
      }
      // Thread  Runnable ʤΤ
      // Thread ǤʤΤ Runnable ɤȽꤹ
      else if (obj instanceof Runnable) {
	// åɤ MobaPlace.threadPool ˽°
	t = new MobaThread(MobaPlace.threadPool, (Runnable)obj);
      }
      else {
	error("The class \"" + className + "\" is neither Runnable nor Thread.");
	continue;
      }
      // λ obj  Thread Υ󥹥

      out.println("Now start the thread instance of \"" + className + "\".");

      t.setName("Thread of " + className);
      t.setDaemon(false);	// make the thread user thread
      try {
	t.setPriority(Thread.NORM_PRIORITY);
      } catch(IllegalArgumentException e) {}

      Logger.log(this, "Thread instance of " + className + "is started.");
      t.start();
    }
  }


  private static final String usageOfmove = "move threadID destination[:port]";
  private static final String descOfmove =
	"Move the thread to the destination machine.";

  public void move(String[] args) {
    if (args.length < 3) {
      error("Command \"move\" requires thread ID and destination.");  return;
    }

    int id = -1;
    try { id = Integer.parseInt(args[1]); }
    catch (NumberFormatException e) {
      error("Format of \"" + args[1] + "\" is illegal.");  return;
    }

    PlaceAddress dest = null;
    try {
      dest = new PlaceAddress(args[2]);
    }
    catch (UnknownHostException e) {
      error("Host \"" + args[2] + "\" is unknown.");  return;
    }
    if (dest.equals(PlaceAddress.localAddress())) {
      error("Destination is the local MOBA place: " + dest);  return;
    }
    

    Object target = threadByID(id, MobaPlace.threadPool);
    if (target == null) {
      error("Thread which has ID \"" + id + "\" doesn't exist.");  return;
    }
    else if (target instanceof MobaThread) {
      try {
	((MobaThread)target).moveTo(dest);
      }
      catch (IOException e) { error("Migration failed: " + e);  return; }
    }
    else {
      error("You cannot move the instance of class \""
		+ target.getClass().getName() + "\".");
      return;
    }
  }


  private static final String usageOffork = "fork threadID destination[:port]";
  private static final String descOffork =
	"Create a replica of the specified thread on the destination machine.";

  public void fork(String[] args) {
    if (args.length < 3) {
      error("Command \"fork\" requires thread ID and destination.");  return;
    }

    int id = -1;
    try { id = Integer.parseInt(args[1]); }
    catch (NumberFormatException e) {
      error("Format of \"" + args[1] + "\" is illegal.");  return;
    }

    PlaceAddress dest = null;
    try {
      dest = new PlaceAddress(args[2]);
    }
    catch (UnknownHostException e) {
      error("Host \"" + args[2] + "\" is unknown.");  return;
    }
    

    Object target = threadByID(id, MobaPlace.threadPool);
    if (target == null) {
      error("Thread which has ID \"" + id + "\" doesn't exist.");  return;
    }
    else if (target instanceof MobaThread) {
      try {
	((MobaThread)target).forkThisThread(dest);
      }
      catch (IOException e) { error("Migration failed: " + e);  return; }
    }
    else {
      error("You cannot move the instance of class \""
		+ target.getClass().getName() + "\".");
      return;
    }
  }


  private static final String usageOfname = "name threadID new_name";
  private static final String descOfname = "Name the thread new name.";

  public void name(String[] args) {
    if (args.length < 3) {
      error("Command \"name\" requires thread ID and new name.");
      return;
    }

    int i = 2;
    StringBuffer buf = new StringBuffer();
    buf.append(args[i++]);
    for (; i < args.length; i++) {
      buf.append(" ");  buf.append(args[i]);
    }
    String newName = buf.toString();

    int id = -1;
    try { id = Integer.parseInt(args[1]); }
    catch (NumberFormatException e) {
      error("Format of \"" + args[1] + "\" is illegal.");
      return;
    }

    Object target = threadByID(id, MobaPlace.threadPool);
    if (target == null) {
      error("Thread which has ID \"" + id + "\" doesn't exist.");
      return;
    }
    else if (target instanceof Thread) {
      ((Thread)target).setName(newName);
    }
    else if (target instanceof ThreadGroup) {
      error("You cannot name thread groups.");
      return;
    }
  }


  private static final String usageOfproperty = "property property_name";
  private static final String descOfproperty =
	"Get property of JVM on which MOBA place is running.";

  public void property(String[] args) {
    if (args.length < 2) {
      error("Command \"run\" takes an argument as property name.");
      return;
    }

    String key = args[1];
    String property = System.getProperty(key);
    out.println(key + " : " + property);
  }


  private static final String usageOfrun = "run {gc,finalization}";
  private static final String descOfrun =
	"Execute garbate collector or finalizer methods of released objects.";

  public void run(String[] args) {
    if (args.length < 2) {
      error("Command \"run\" takes an argument, \"gc\" or \"finalization\".");
      return;
    }

    String cmd = args[1].toLowerCase();
    if (cmd.startsWith("g")) {
      System.gc();
    }
    else if (cmd.startsWith("f")) {
      System.runFinalization();
    }
    else {
      error("Command \"run\" takes an argument, \"gc\" or \"finalization\".");
      return;
    }
  }


  // ޥο
  private static final String usageOfhalt = "halt";
  private static final String descOfhalt = "Stop the MOBA place.";

  public void halt(String[] args) {
    out.println("Now halting the MOBA place.");
    System.exit(0);
  }


  private static final String usageOfquit = "quit";
  private static final String descOfquit =
	"Terminate this command shell and cut the connection to the place.";

  public void quit(String[] args) {
    out.println("Done.");
    this.shell.quit();
  }


  private static final String usageOfhelp = "help [command ...]";
  private static final String descOfhelp = "Display usage of commands.";

  public void help(String[] args) {
    if (args.length < 2) {
      out.println("This shell accepts the following commands.");
      out.println("Shortened form is also acceptable.");
      out.println("The latter in this list is adopted if the input is vague.");
      out.print(usageAll);
    }
    else {
      for (int i = 1; i < args.length; i++) {
	String arg = args[i];
	String usage = (String)usageTable.get(arg);
	String desc = (String)descTable.get(arg);

	if ((usage == null) && (desc == null)) {
	  error("Command \"" + arg + "\" doesn't exist.");
	  continue;
	}

	out.print("usage: ");
	out.print(usage);
	out.println();

	out.print(Command.helpIndent);
	out.print(desc);
	out.println();
      }
    }
  }


/*
  // ޥο
  private static final String usageOfcommand = "";
  private static final String descOfcommand = "";

  public void command(String[] args) {
    for (int i = 1; i < args.length; i++) {
      String arg = args[i];
    }
  }
*/
}
