import java.io.IOException;

import NET.shudo.moba.lang.MobaThread;


/**
  Skelton class for Thread Migration facility of MOBA.

  % java classname hostname_the_thread_jump_to

  @author SHUDOH Kazuyuki
 */
class MobaSkelton {
  private void start(String[] argv) {
    // åɤεư
    Runnable r;
    if (argv.length > 0)
      r = new MobaMigrant(argv[0]);
    else
      r = new MobaMigrant();
    Thread t = new MobaThread(r);	// ¸ǽ Thread 饹
    t.start();


    // ưåɤνλԤ
    boolean joined = true;
    do {
      try {
	t.join();
      } catch (InterruptedException e) { joined = false; }
    } while (!joined);
  }


  public static void main(String[] argv) {
    new MobaSkelton().start(argv);
  }
}


/**
 * ư륹å
 */
class MobaMigrant implements Runnable {
  private static final String DEFAULT_HOST = "host.defaultdomain.com";

  private String host = null;

  public MobaMigrant() {
    this(DEFAULT_HOST);
  }
  public MobaMigrant(String host) {
    this.host = host;
  }


  public void run() {
    try {
      // Now I jump to the machine which name is this.host!
      MobaThread.goTo(this.host);
    }
    catch (IOException e) {
      e.printStackTrace();  Thread.currentThread().stop();
    }


    if (((MobaThread)Thread.currentThread()).isInternalized()) {
      System.out.println("I've migrated !");
    }
    else {
      System.out.println("Migration is done.");
	// This message is never shown
	// because he, current thread is gone. :)
    }
  }
}
