/**
  Sample code for thread externalizer
  in package NET.shudo.moba.
  Copy this file to the directory which is in CLASSPATH and compile
    % javac ThreadWriterTest.java
  and execute:
    % java ThreadWriterTest

  @author SHUDOH Kazuyuki
 */

import java.io.FileOutputStream;
import java.io.FileInputStream;
import java.io.IOException;

import NET.shudo.moba.lang.MobaThread;
import NET.shudo.moba.io.ObjectWriter;
import NET.shudo.moba.io.ObjectReader;
import NET.shudo.moba.io.ThreadWriter;
import NET.shudo.moba.io.ThreadReader;

import NET.shudo.moba.util.ThreadLister;


class ThreadWriterTest {
  private static final int NTHREADS = 3;
  private static final String THREAD_FNAME = "output";

  private void start() {
    Thread[] threads = new Thread[NTHREADS];
    int i;

    // åɷεư
    for (i = 0; i < NTHREADS; i++) {
      Runnable r = new DotWriter();	// 1äˤҤȤ `.' ɽ륹å

      threads[i] = new MobaThread(r);	// ¸ǽ Thread 饹
      threads[i].start();
      try {
	Thread.sleep(210);	// åɤֳ
      }
      catch (InterruptedException e) { e.printStackTrace();  System.exit(1); }
    }


    // sleep
    try {
      Thread.sleep(4500);
    }
    catch (InterruptedException e) { e.printStackTrace(); System.exit(1); }


    // 񤭽Ф
    for (i = 0; i < NTHREADS; i++) {
      Thread t = threads[i];
      //t.suspend();	// 

      try {
	ObjectWriter out =
	  new ThreadWriter(new FileOutputStream(THREAD_FNAME + i));
	out.writeObject(t);
	out.close();
      }
      catch (IOException e) { e.printStackTrace();  System.exit(1); }

      System.out.println("Thread Externalization is successful.");
    }


    // ɤ߹
    Thread t = null;
    for (i = 0; i < NTHREADS; i++) {
      try {
	ObjectReader in =
		new ThreadReader(new FileInputStream(THREAD_FNAME + i));
	t = (Thread)in.readObject();
      }
      catch (Exception e) { e.printStackTrace();  System.exit(1); }
      System.out.println("Thread Internalization is successful.\n");

      // ɤ߹åɤ resume
      t.resume();
    }


//    (new ThreadLister()).listAllThreads(System.out);


/*
    System.out.println("PC(1): " + ((MobaThread)t).currentPCString());
    try {
      Thread.sleep(1000);
    }
    catch (InterruptedException e) { e.printStackTrace();  System.exit(1); }
    System.out.println("PC(2): " + ((MobaThread)t).currentPCString());
*/


/*	
    boolean joinDone = false;
    do {
      joinDone = true;
      try {
	threads[0].join();
      }
      catch (InterruptedException e) { joinDone = false; }
    } while (!joinDone);
*/
  }

  public static void main(String[] argv) {
    new ThreadWriterTest().start();
  }
}
